package org.netkernel.layer0.meta.impl;

import org.netkernel.layer0.meta.IPrototypeParameterMeta;

public class PrototypeParameterMetaImpl extends MetaRepresentationImpl implements IPrototypeParameterMeta
{
	private final Class mRepresentationalClass;
	private final Object mDefault;
	private final int mMaxValency;
	private final int mMinValency;
	
	public PrototypeParameterMetaImpl(String aName, String aDesc, Class aRepresentationalClass, Object aDefault)
	{	this(aName,aDesc,aRepresentationalClass,aDefault,(aDefault==IPrototypeParameterMeta.NO_DEFAULT)?1:0,1);
	}	
	
	public PrototypeParameterMetaImpl(String aName, Class aRepresentationalClass, Object aDefault)
	{	this(aName,null,aRepresentationalClass,aDefault,(aDefault==IPrototypeParameterMeta.NO_DEFAULT)?1:0,1);
	}
	
	public PrototypeParameterMetaImpl(String aName, String aDesc, Class aRepresentationalClass, Object aDefault,  int aMinValency, int aMaxValency)
	{	super(aName,aDesc,null,null);
		mRepresentationalClass=aRepresentationalClass;
		mDefault=aDefault;
		mMaxValency=aMaxValency;
		mMinValency=aMinValency;
	}
	
	public Object getDefault()
	{	return mDefault;
	}

	public Class getRepresentationalClass()
	{	return mRepresentationalClass;
	}

	public int getMaximumValency()
	{	return mMaxValency;
	}

	public int getMinimumValency()
	{	return mMinValency;
	}
}