package org.netkernel.layer0.nkf.impl;

import java.util.List;

import org.netkernel.layer0.nkf.INKFExpiryFunction;
import org.netkernel.request.IExpiry;

public class NKFListExpiry implements INKFExpiryFunction
{
	private IExpiry[] mExpiryDeterminants;
	
	public NKFListExpiry(List aExpiryDeterminants)
	{
		mExpiryDeterminants = new IExpiry[aExpiryDeterminants.size()];
		for (int i=0; i<mExpiryDeterminants.length; i++)
		{	mExpiryDeterminants[i]=(IExpiry)aExpiryDeterminants.get(i);
		}
	}
	
	public boolean isExpired(long aNow)
	{	boolean expired=false;
		for (int i=mExpiryDeterminants.length-1; i>=0 && !expired; i--)
		{	expired=mExpiryDeterminants[i].isExpired(aNow);
		}
		return expired;
	}

}
